<script src="https://cdnjs.cloudflare.com/ajax/libs/echarts/4.8.0/echarts-en.common.min.js" 
    integrity="sha512-/Q40jZijQiufYjvG6aiUq9PTUrOt/E9igis1ZLbZv89yl2FIsSwgeZr6w7WipE6ALQ5DuWME/BSCl9F0u0eunQ==" 
    crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/circles/0.0.6/circles.min.js" integrity="sha512-r1w3tnPCKov9Spj2bJGCQQBJ5wcJywFgL79lKMXvzBMXIPFI9xXQDmwuVs+ERh1tnL0UFT1hLrwtKh1z5/XCCQ==" crossorigin="anonymous"></script>

<script>
    var sdcAll = document.getElementById('sdc-all');
    var sdcAllTime = document.getElementById('sdc-all-time');
    var sdcAllTest = $('#sdc-all-test');
    var sdcEachTest = document.getElementById('sdc-each-test');
    var sdcEachTestQuestion = document.getElementById('sdc-each-test-question');
    
    function renderGauge(divid, value, size = 45) {
        Circles.create({
                id: divid,
                radius: size,
                value: value >= 0 ? value : 0,
                maxValue:100,
                width:8,
                text: Math.round(value)  + '%',
                colors:['#f1f1f1',edgar.getColorForPercentage(value)],
                duration:400
            });
    }
    async function getCourseAnalytics() {
        var student = await $.get('/analytics/score/student/<%- student.id %>/scores?testId=0');
        
        student.overallScore = 100 * student.winnedScore / student.maxWinnableScore;
        renderGauge('circles-minScore', student.minScore );
        renderGauge('circles-maxScore', student.maxScore );
        renderGauge('circles-avgScore', student.avgScore );
        renderGauge('circles-percentile', student.percentileRank );
        renderGauge('circles-percentage-attempted', student.score );
        renderGauge('circles-percentage', student.overallScore);
        
        $('#winnedScore').html(student.winnedScore ? student.winnedScore : '-');
        $('#maxWinnableScore').html(student.maxWinnableScore ? student.maxWinnableScore : '-');
        $('#rank').html(student.rank ? student.rank : '-');
        $('#maxRank').html(student.maxRank ? student.maxRank : '-');
        $('#attendedTests').html(student.attendedTests ? student.attendedTests : '-');
        $('#heldTests').html(student.heldTests ? student.heldTests : '-');

        return student;
    }

    function getAnalytics(resolution = 5, testId = 0, myscore) {
        var sdcAllChart = echarts.init(sdcAll);
        sdcAllChart.clear();
        var g1 = $.get('/analytics/score/distribution/total?resolution=' + resolution + '&testId=' + testId);

        $.when(g1).done(function (total) {
            
            var studentPercentile = Math.floor(myscore / resolution) * resolution;

            var option = {
                legend: {
                    data: total.map(item => item.y)
                },
                title: {
                    text: 'Overall score distribution',
                    subtext: 'Score distribution across all tests in the course'
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                calculable: true,
                xAxis: {
                    name: 'Score percentage',
                    nameLocation: 'center',
                    nameGap: 25,
                    type: 'category',
                    data: total.map(item => item.x)
                },
                yAxis: {
                    name: 'Number of students',
                    nameGap: 25,
                    nameLocation: 'center',
                    nameRotate: 90,
                    type: 'value'
                },
                series: [{
                    data: total.map(item => ({
                        value: item.y,
                        itemStyle: {
                            color: item.x == studentPercentile ? edgar.getColorForPercentage(myscore) : 'gray',
                            borderColor: 'black',
                        },                        
                        label: {
                            show: item.x == studentPercentile ? 'true' : 'false',
                            position: 'top',
                            formatter: (data) => item.x == studentPercentile ? Math.round(10 * myscore)/10 : '',
                        }
                    })),
                    type: 'bar'
                }]
            };

            sdcAllChart.setOption(option);
        });    
    }

    function getTestTimeAnalytics(resolution = 10, testId = 0, studentId, maxRank) {
        var sdcAllChart = echarts.init(sdcAllTime);
        sdcAllChart.clear();
        var g1 = $.get('/analytics/score/distribution/time?resolution=' + resolution + '&testId=' + testId + '&studentId=' + studentId);

        $.when(g1).done(function (total) {
            var option = {
                title: {
                    text: 'Average test score',
                    subtext: 'My score vs average score for each test'
                },
                legend: {
                    data: ['Avg score', 'Rank'],
                    right: 0
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                calculable: true,
                xAxis: {
                    name: '',
                    nameLocation: 'center',
                    nameGap: 0,
                    axisLabel: {
                        interval: 0,
                        rotate:"45"
                    },
                    type: 'category',
                    data: total.map(item => item.x + ' \n(' + item.n + ')' )
                },
                yAxis: [{
                    name: 'Score percentage',
                    nameGap: 25,
                    nameLocation: 'center',
                    nameRotate: 90,
                    type: 'value'
                }, {
                    name: 'Rank',
                    nameGap: 25,
                    nameLocation: 'center',
                    nameRotate: 90,
                    type: 'value',
                    inverse: true,
                    min: 1,
                    max: maxRank
                }],
                series: [{
                    data: total.map(function(item){
                        
                        return {
                            value: item.y,
                            itemStyle: {
                                color:  (item.y >= item.y2)  ? 'green' : 'red',
                                borderColor: 'black',
                            },                        
                            label: {
                                show: (item.y > 0) ,
                                position: 'top',
                                formatter: (data) =>  Math.round(100 * (item.y - item.y2) / item.y2) + '%',
                            }
                        };
                    }),
                    type: 'bar',
                    name: 'My score'
                }, {
                    data: total.map(item => item.y2),
                    type: 'line',
                    name: 'Avg score',
                    lineStyle: {
                        color: 'black',
                        width: 2,
                    },
                    itemStyle: {
                        borderWidth: 2,
                        borderColor: 'black',
                        color: 'black'
                    }
                }, {
                    data: total.map(item => item.y3),
                    type: 'line',
                    name: 'Rank',
                    yAxisIndex: 1,
                    lineStyle: {
                        color: 'blue',
                        width: 2,
                    },
                    itemStyle: {
                        borderWidth: 2,
                        borderColor: 'blue',
                        color: 'blue'
                    }
                }]
            };

            sdcAllChart.setOption(option);
        });
    }

    function getTestAnalytics(resolution = 10, testId = 0, studentId) {
        var sdcEachTestChart = echarts.init(sdcEachTest);
        var sdcEachTestQuestionChart = echarts.init(sdcEachTestQuestion);
        sdcEachTestChart.clear();
        sdcEachTestQuestionChart.clear();

        var g1 = $.get('/analytics/score/distribution/total?resolution=' + resolution + '&testId=' + testId),
            g2 = $.get('/analytics/score/student/<%- student.id %>/scores?testId=' + testId),
            g3 = $.get('/analytics/score/distribution/timeQuestion?resolution=' + resolution + '&testId=' + testId + '&studentId=' + studentId);

        var total, student, test;

        $.when(g1, g2, g3).done(function (totalResp, studentResp, testResp) {
            
            total = totalResp[0],
            student = studentResp[0];
            test = testResp[0];

            var studentPercentile = Math.round(student.score / 10) * 10;

            var option = {
                title: {
                    text: 'Exam score percentage distribution (n = ' + student.maxRank + ')',
                    subtext: 'Score distribution for all students vs mine'
                },
                legend: {
                    data: total.map(item => item.y)
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                calculable: true,
                xAxis: {
                    name: 'Score percentage',
                    nameLocation: 'center',
                    nameGap: 25,
                    type: 'category',
                    data: total.map(item => item.x)
                },
                yAxis: {
                    name: 'Number of students',
                    nameGap: 25,
                    nameLocation: 'center',
                    nameRotate: 90,
                    type: 'value'
                },
                series: [{
                    data: total.map(item => ({
                        value: item.y,
                        itemStyle: {
                            color: item.x == studentPercentile ? edgar.getColorForPercentage(student.score) : 'gray',
                            borderColor: 'black',
                            borderWidth: 2,
                        },
                        label: {
                            show: item.x == studentPercentile ? 'true' : 'false',
                            position: 'top',
                            formatter: (data) => item.x == studentPercentile ? student.score : '',
                        }
                    })),
                    type: 'bar'
                }]
            };

            sdcEachTestChart.setOption(option);
            
            var optionQuestions = {
                title: {
                    text: 'Per Question',
                    subtext: 'My score vs average score for each question'
                },
                legend: {
                    data: ['Avg score'],
                    right: 0
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                calculable: true,
                xAxis: {
                    name: 'Question',
                    nameLocation: 'center',
                    nameGap: 25,
                    type: 'category',
                    data: test.map(item => item.x)
                },
                yAxis: [{
                    name: 'Score (points)',
                    nameGap: 25,
                    nameLocation: 'center',
                    nameRotate: 90,
                    type: 'value'
                }],
                series: [{
                    data: test.map(function(item){
                        
                        return {
                            value: item.y,
                            itemStyle: {
                                color:  (item.y >= item.y3)  ? 'green' : 'red',
                                borderColor: 'black',
                            },                        
                            label: {
                                show: (item.y > 0) ,
                                position: 'top',
                                formatter: (data) =>  Math.round(100 * (item.y - item.y2) / item.y2) + '%',
                            }
                        };
                    }),
                    type: 'bar',
                    name: 'My score'
                }, {
                    data: test.map(item => item.y2),
                    type: 'line',
                    name: 'Avg score (same ordinal)',
                    lineStyle: {
                        color: 'black',
                        width: 2,
                    },
                    itemStyle: {
                        borderWidth: 2,
                        borderColor: 'black',
                        color: 'black'
                    }
                }, {
                    data: test.map(item => item.y3),
                    type: 'line',
                    name: 'Avg score (same question)',
                    lineStyle: {
                        color: 'blue',
                        width: 2,
                    },
                    itemStyle: {
                        borderWidth: 2,
                        borderColor: 'black',
                        color: 'blue'
                    }
                }]
            };
            
            sdcEachTestQuestionChart.setOption(optionQuestions);

            $('#eachTestRank').html(student.rank ? student.rank : '-');
            $('#eachTestMaxRank').html(student.maxRank ? student.maxRank : '-');
            renderGauge('circles-eachTestPercentile', student.percentileRank, 30);
            renderGauge('circles-eachTestPercentage', student.score, 30);
            //$('#eachTestPercentile').html(student.percentile ? student.percentile : '-');
            $('#eachTestWinnedScore').html(student.winnedScore ? student.winnedScore : '-');
            $('#eachTestMaxWinnableScore').html(student.maxWinnableScore ? student.maxWinnableScore : '-');
        });    
    }

    getCourseAnalytics()
    .then(function(student) {
        getAnalytics(5, 0, student.overallScore);
        getTestTimeAnalytics(5, 0, <%- student.id %>, student.maxRank);
    }).catch(error => {
        alert('error occured ', error);
    });
    
    
    getTestAnalytics(5, $(sdcAllTest).val(),  <%- student.id %>);

    sdcAllTest.on('change', function () {
        getTestAnalytics(5, $(this).val(),  <%- student.id %>);
    });
</script>